Subject: Re: [PATCH v1] perf pmu: Fix aarch64 build

From: Arnaldo Carvalho de Melo <[email-masked]>
Date: Fri, 3 Feb 2023 11:35:28 -0300

Em Fri, Feb 03, 2023 at 11:17:38AM -0300, Arnaldo Carvalho de Melo escreveu:
> Em Thu, Feb 02, 2023 at 05:41:22PM -0800, Ian Rogers escreveu:
> > On Thu, Feb 2, 2023 at 5:40 PM Ian Rogers <[email-masked]> wrote:
> > >
> > > ARM64 overrides a weak function but a previous change had broken the
> > > build.
> > >
> > > Fixes: 8cefeb8bd336 ("perf pmu-events: Introduce pmu_metrics_table")
> > 
> > As 8cefeb8bd336 ("perf pmu-events: Introduce pmu_metrics_table") is
> > only on tmp.perf/core then it may be best to just squash this fix into
> > that.
> 
> Yeah, that was my intention, I'll fold it there to keep bisection,
> thanks for fixing it so fast, I'll double check on my rk3399 board and
> on again on the cross-build container.

Nope, that is not what I reported yesterday, trying to build it on the
rk3399 board:

acme@roc-rk3399-pc:~/git/perf$ cat /etc/os-release
PRETTY_NAME="Ubuntu 22.04.1 LTS"
NAME="Ubuntu"
VERSION_ID="22.04"
VERSION="22.04.1 LTS (Jammy Jellyfish)"
VERSION_CODENAME=jammy
ID=ubuntu
ID_LIKE=debian
HOME_URL="https://www.ubuntu.com/"
SUPPORT_URL="https://help.ubuntu.com/"
BUG_REPORT_URL="https://bugs.launchpad.net/ubuntu/"
PRIVACY_POLICY_URL="https://www.ubuntu.com/legal/terms-and-policies/privacy-policy"
UBUNTU_CODENAME=jammy
acme@roc-rk3399-pc:~/git/perf$

 CC      /tmp/build/perf/arch/arm64/util/pmu.o
  CC      /tmp/build/perf/bench/epoll-wait.o
arch/arm64/util/pmu.c: In function ‘pmu__find_core_pmu’:
arch/arm64/util/pmu.c:27:33: error: declaration of ‘pmu_metrics_table__find’ shadows a global declaration [-Werror=shadow]
   27 | const struct pmu_metrics_table *pmu_metrics_table__find(void)
      |                                 ^~~~~~~~~~~~~~~~~~~~~~~
In file included from arch/arm64/util/pmu.c:5:
arch/arm64/util/../../../util/pmu.h:234:33: note: shadowed declaration is here
  234 | const struct pmu_metrics_table *pmu_metrics_table__find(void);
      |                                 ^~~~~~~~~~~~~~~~~~~~~~~
arch/arm64/util/pmu.c: In function ‘pmu_metrics_table__find’:
arch/arm64/util/pmu.c:29:26: error: declaration of ‘pmu’ shadows a previous local [-Werror=shadow]
   29 |         struct perf_pmu *pmu = pmu__find_core_pmu();
      |                          ^~~
arch/arm64/util/pmu.c:11:26: note: shadowed declaration is here
   11 |         struct perf_pmu *pmu = NULL;
      |                          ^~~
arch/arm64/util/pmu.c: In function ‘pmu__find_core_pmu’:
arch/arm64/util/pmu.c:27:1: error: ISO C90 forbids mixed declarations and code [-Werror=declaration-after-statement]
   27 | const struct pmu_metrics_table *pmu_metrics_table__find(void)
      | ^~~~~
arch/arm64/util/pmu.c:37:32: error: declaration of ‘pmu_events_table__find’ shadows a global declaration [-Werror=shadow]
   37 | const struct pmu_events_table *pmu_events_table__find(void)
      |                                ^~~~~~~~~~~~~~~~~~~~~~
In file included from arch/arm64/util/pmu.c:5:
arch/arm64/util/../../../util/pmu.h:233:32: note: shadowed declaration is here
  233 | const struct pmu_events_table *pmu_events_table__find(void);
      |                                ^~~~~~~~~~~~~~~~~~~~~~
arch/arm64/util/pmu.c: In function ‘pmu_events_table__find’:
arch/arm64/util/pmu.c:39:26: error: declaration of ‘pmu’ shadows a previous local [-Werror=shadow]
   39 |         struct perf_pmu *pmu = pmu__find_core_pmu();
      |                          ^~~
arch/arm64/util/pmu.c:11:26: note: shadowed declaration is here
   11 |         struct perf_pmu *pmu = NULL;
      |                          ^~~
arch/arm64/util/pmu.c: In function ‘pmu__find_core_pmu’:
arch/arm64/util/pmu.c:47:8: error: declaration of ‘perf_pmu__cpu_slots_per_cycle’ shadows a global declaration [-Werror=shadow]
   47 | double perf_pmu__cpu_slots_per_cycle(void)
      |        ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
In file included from arch/arm64/util/pmu.c:5:
arch/arm64/util/../../../util/pmu.h:255:8: note: shadowed declaration is here
  255 | double perf_pmu__cpu_slots_per_cycle(void);
      |        ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
arch/arm64/util/pmu.c: In function ‘perf_pmu__cpu_slots_per_cycle’:
arch/arm64/util/pmu.c:51:26: error: declaration of ‘pmu’ shadows a previous local [-Werror=shadow]
   51 |         struct perf_pmu *pmu = pmu__find_core_pmu();
      |                          ^~~
arch/arm64/util/pmu.c:11:26: note: shadowed declaration is here
   11 |         struct perf_pmu *pmu = NULL;
      |                          ^~~
arch/arm64/util/pmu.c: In function ‘pmu__find_core_pmu’:
arch/arm64/util/pmu.c:64:1: error: expected declaration or statement at end of input
   64 | }
      | ^
At top level:
arch/arm64/util/pmu.c:47:8: error: ‘perf_pmu__cpu_slots_per_cycle’ defined but not used [-Werror=unused-function]
   47 | double perf_pmu__cpu_slots_per_cycle(void)
      |        ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
arch/arm64/util/pmu.c:37:32: error: ‘pmu_events_table__find’ defined but not used [-Werror=unused-function]
   37 | const struct pmu_events_table *pmu_events_table__find(void)
      |                                ^~~~~~~~~~~~~~~~~~~~~~
arch/arm64/util/pmu.c:27:33: error: ‘pmu_metrics_table__find’ defined but not used [-Werror=unused-function]
   27 | const struct pmu_metrics_table *pmu_metrics_table__find(void)
      |                                 ^~~~~~~~~~~~~~~~~~~~~~~
cc1: all warnings being treated as errors
make[6]: *** [/home/acme/git/perf/tools/build/Makefile.build:98: /tmp/build/perf/arch/arm64/util/pmu.o] Error 1
make[5]: *** [/home/acme/git/perf/tools/build/Makefile.build:140: util] Error 2
make[4]: *** [/home/acme/git/perf/tools/build/Makefile.build:140: arm64] Error 2
make[3]: *** [/home/acme/git/perf/tools/build/Makefile.build:140: arch] Error 2
make[3]: *** Waiting for unfinished jobs....